# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building

class Waterpump(base_building.BaseBuilding):
    def __init__(self, cdata):
        base_building.BaseBuilding.__init__(self, cdata)
        self.ser_name = 'Waterpump'
        #self.to_building_subtype = "__store__"
        self.SetIsHome(False)
# ============================================================
    def need_base_resource(self):
        return False
# ============================================================
    def on_res_gen_started(self):
        pass
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        pass
# ============================================================
    def on_minimal_effectiveness(self):
        pass
# ============================================================
    #@override
    def need_to_show_unit(self):
        return False
# ============================================================
    #@override
    def need_no_action(self):
        return False
# ============================================================
    #@override
    def need_pers_no_action(self):
        return False
# ============================================================
    def init_anim(self):
        self.Drawer.SetAnimationEvent('unit', 10, 'worker_event')
        settings = []
        settings.append( ['unit', ('random', 8, 10)] )
        settings.append( ['pers_no_action', 5] )
        self.anim_helper.set_animations('default', settings)
# ============================================================
    #@override
    def on_worker_in(self, unit):
        '''Чтобы здание могло отловить когда пришел юнит-работник в здание'''
        base_building.BaseBuilding.on_worker_in(self, unit)
        self.init_anim()
        self.anim_helper.start_group('default')
# ============================================================
    def on_upgrade_complete(self, building_info):
        base_building.BaseBuilding.on_upgrade_complete(self, building_info)
        self.Drawer.SetAnimationEvent('unit', 10, 'worker_event')
# ============================================================
    #@override
    def on_awaiting_action(self):
        self.anim_helper.hide()
        self.anim_helper.stop()
# ============================================================
    # @override
    def _start_resource_generation(self):
        self.anim_helper.start_group('default')
# ============================================================
    # @override
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        if msg_type == 'worker_event':
            self.PlaySound('SND_WATERPUMP_UNIT_SOUND')
# ============================================================