# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class EnablerSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'EnablerSubtask'
        self.actor_action_animation = 'pickup'

    def start_action(self, item):
        self.actor.stop_walk()
        item.action_started = True
        self.actor.action_hit_item(item)     # генерал сам доломает горшок, BUG: возможен, если отмена произойдет в момент ломания
        return True
# ============================================================
# ============================================================
class Enabler(base_diff_item.DiffItem):
    '''Переключатель'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'Enabler'
        self.task = None
        self.snd_complete = self.GetAttrStr('snd_complete', 'SND_STONEDOOR_SWITCH')
        self.snd_hit = self.GetAttrStr('snd_hit', 'SND_POT_HIT')
# ============================================================
    #@override
    def on_create(self):
        base_diff_item.DiffItem.on_create(self)
        self.add_attention_signal()
# ============================================================
    #@override
    def is_action_complete(self):
        '''Действие [юнитом] над данным объектом уже было выполнено'''
        if self.action_hits_last <= 0:
            return True
        elif not self.action_started:
            return True
        return False
# ============================================================
    #@override
    def on_action_hits_me_complete(self):
        self.do_default_action()
# ============================================================
    def do_default_action(self):
        _linked_uids = self.GetAttrStr('linked_uids')
        _cur_variant = self.get('variant_name')
        self.action_started = False # заканчиваем действие
        self.action_was_started = False
        self.switch_variant( ('default', 'complete')[_cur_variant != 'complete'] )
        #self.action_hits_last = 0
        enabler_info = {'type':self.get('type'), 'subtype':self.get('subtype')}
        EMgr.send_event( 'enabler_action', self, enabler_info )
        #self.PlaySound('SND_POT_CRASH')
        self.send_extra_event()
        #BMgr.remove_item_uid(self)
        _linked_items = BMgr.get_items(_linked_uids, self.get('locind'))
        if _linked_items:
            self.PlaySound(self.snd_complete)
        # открываем двери и прочее:
        for _item in _linked_items:
            try:
                _item.do_action_enable()
            except: pass
# ============================================================
    def get_subtask(self, parent_task, actor):
        if self.key_need:
            _has_key = self.has_key()
            if _has_key:
                return base_diff_item.OpenKeySubtask(parent_task, actor)
            else: return None
        else:
            return EnablerSubtask(parent_task, actor)
# ============================================================
    def play_hit_sound(self):
        self.PlaySound(self.snd_hit)
# ============================================================
    # #@override
    #def get_action_text(self, for_task_slide = False):
    #    return 'DLG_TASK_BREAK_POT'
# ============================================================
    #@override
    def _do_action(self, name):
        if name == 'default':
            self.do_default_action()
            return True
        return False
# ============================================================
# #######################################################
# #######################################################
# #######################################################
