# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog

class HelpDlg(dialog.Dialog):
    dlg_next = {0: 1, 1: 2, 2: 3, 3: 4, 4: 5, 5: 6, 6:7, 7:8, 8:9, 9:10, 10: 11, 11: 0}
    dlg_prev = {0: 11, 11: 10, 10:9, 9:8, 8:7, 7:6, 6: 5, 5: 4, 4: 3, 3: 2, 2: 1, 1: 0}

    index_to_dlg = {    0: 'HelpMenu',
                        1: 'HelpMenu_0',
                        2: 'HelpMenu_1',
                        3: 'HelpMenu_2',
                        4: 'HelpMenu_3',
                        5: 'HelpMenu_4',
                        6: 'HelpMenu_5',
                        7: 'HelpMenu_6',
                        8: 'HelpMenu_7',
                        9: 'HelpMenu_8',
                        10: 'HelpMenu_9',
                        11: 'HelpMenu_10'}
    dlg_to_index = {    'HelpMenu':0,
                        'HelpMenu_0':1,
                        'HelpMenu_1':2,
                        'HelpMenu_2':3,
                        'HelpMenu_3':4,
                        'HelpMenu_4':5,
                        'HelpMenu_5':6,
                        'HelpMenu_6':7,
                        'HelpMenu_7':8,
                        'HelpMenu_8':9,
                        'HelpMenu_9':10,
                        'HelpMenu_10':11}
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'fullscreen'
        # если нужно, то доп. параметры можно вытащить из params
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == "enter":
            pass
        elif type == "exit":
            pass
        elif type == "change":
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        #if command == 'mouse_up':
        #    DLG.PauseGame(False)
        #    DLG.StartUnfade()
        #    DLG.Close_dialog(self)
        if command == 'keycode':
            if param in ['space', 'enter', 'escape']:
                DLG.PauseGame(False)
                DLG.StartUnfade()
                DLG.Close_dialog(self)
        pass
# ============================================================
    def on_create(self):
        self.ShowSpaceHolders()
        #tools.PlaySound('SND_WINDOW_OPEN')
        DLG.PauseGame(True)
        DLG.PMgr.set_user_setting('help_button_clicked', 1)
        DLG.PMgr.save_current_user()

        max_index = DLG.PMgr.cur_user_stat.help_shown
        if max_index == 0:
            for id in ['idNextBtn', 'idPrevBtn', 'idNextBG', 'idPrevBG']:
                self.ShowWidget(id, False)
# ============================================================
    def on_button(self, id):
        if id == 'idOkBtn':
            self.HideSpaceHolders()
            DLG.PauseGame(False)
            DLG.StartUnfade()
            DLG.Close_dialog(self)
        elif id == 'idNextBtn':
            #DLG.StartUnfade()
            DLG.Close_dialog(self)
            max_index = DLG.PMgr.cur_user_stat.help_shown
            if max_index == 0: return
            index = self.dlg_to_index[self.xml_name]
            if index >= max_index: index = 11  # чтобы на начало перейти
            next_index = self.dlg_next[index]
            next_name = self.index_to_dlg[next_index]
            DLG.Open_dialog(next_name, 'dlg_help')
        elif id == 'idPrevBtn':
            #DLG.StartUnfade()
            DLG.Close_dialog(self)
            max_index = DLG.PMgr.cur_user_stat.help_shown
            if max_index == 0: return
            index = self.dlg_to_index[self.xml_name]
            prev_index = self.dlg_prev[index]
            if prev_index > max_index: prev_index = max_index
            prev_name = self.index_to_dlg[prev_index]
            DLG.Open_dialog(prev_name, 'dlg_help')
        pass
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
