# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

# ============================================================
# ============================================================
class FSMState(object):
    def __init__(self, item = None):
        self.item = item
        #self.FSM = item.FSM
        self.ser_name = '__none_fsmstate__'
# ============================================================
    def can_enter(self, event_id):
        return True
# ============================================================
    def can_exit(self, event_id):
        return True
# ============================================================
    def on_enter(self, event_id):
        pass
# ============================================================
    def on_exit(self, next_state):
        pass
# ============================================================
    def on_handle(self, event_id):
        pass
# ============================================================
    def on_state_changed(self):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
# ============================================================

class StateInit(FSMState):
    name = 'init'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateInit'
    #def on_handle(evID):
    #    if evID == 'load_init_event':
    #        self.item.
# ============================================================
# ============================================================
class StateNormal(FSMState):
    name = 'normal'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateNormal'

    def on_enter(self, evID):
        pass

    def on_handle(self, evID):
        if evID == 'res_unit_in_event': # для штаба (он в normal состоянии)
            self.item.is_wait_res_unit = False
            b = self.item
            _unit = b.res_unit
            if _unit:
                b.take_resource(_unit.resource) # передаем ресурс
                _unit.resource = None
                #mbox(b.get('name'))
# ============================================================
class StateBuilding(FSMState):
    name = 'building'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateBuilding'

    def on_enter(self, evID):
        b = self.item
        b.show_clock(False)  # песочные часы ожидания
        b.on_before_building_complete()
        b.SM.SetState('build')
        b.on_build_started()
        BMgr.SendGlobalMsg('build_started')
        b.PlaySoundG('SND_BUILDING_LOOP')
        b.Drawer.RestartEffect('build')

    def on_exit(self, next_state):
        b = self.item
        b.SM.SetState('normal')
        b.switch_level('builded')   # переключаемся на следующий вариант
        # ---
        building_info = {'type':b.get('type'), 'subtype':b.get('subtype'), 'uid':b.get('uid')}
        EMgr.send_event( 'build_building_complete', b, building_info )
        _stype = b.get('stype')
        if _stype not in ['bridge']:
            EMgr.send_event( 'building_built', b )  # для prizes
        if b.is_priority_building:
            EMgr.send_event('priority_complete', b, building_info)
            b.is_priority_building = False
        b._on_build_complete(building_info)
        BMgr.SendGlobalMsg('build_completed')
        BMgr.SendGlobalMsg('buildings_count_change')
# ============================================================
class StateBuildWait(FSMState):
    name = 'build_wait'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateBuildWait'

    def on_enter(self, evID):
        b = self.item
        b.show_clock()  # песочные часы ожидания
        _is_fixed_place = b.GetAttrBool('fixed_place')
        if _is_fixed_place:
            b.switch_level_to_place()           # переключим здание на шаблон, который можно строить
        b.SM.SetState('awaiting_action')
        BMgr.SuspendPriority(b.get('name'))
        BMgr.SuspendBuildTemplate(b.get('name'), True)
        b.is_priority_building = True
        b.on_awaiting_action()

    def on_handle(self, evID):
        if evID == 'cancel_event':
            b = self.item
            b.show_clock(False)  # песочные часы ожидания
            task = b.get_participating_task('build_building')
            if task:    # если строили новое здание, но отменили
                b.PlaySoundG('SND_CLICK_TASK_CANCEL')
                task.cancel()
                #_is_fixed_place = b.GetAttrBool('fixed_place')
                #if not _is_fixed_place:     # потому что предустановленное здание на поле остается!
                BMgr.remove_building(b)
                b.unreserve_action_cells()
                b.SM.SetState('normal')
            BMgr.UnsuspendPriority(b.get('name'))
            BMgr.SuspendBuildTemplate(b.get('name'), False)
            b.is_priority_building = False
        elif evID == 'cancel_mapplace_event':
            b = self.item
            b.show_clock(False)  # песочные часы ожидания
            task = b.get_participating_task('build_building')
            if task:    # если строили новое здание, но отменили
                b.PlaySoundG('SND_CLICK_TASK_CANCEL')
                task.cancel()
                b.on_mouse_in('button')
                b.unreserve_action_cells()
                b.SM.SetState('normal')
                b.cancel_switch_level_to_place()
            BMgr.UnsuspendPriority(b.get('name'))
            BMgr.SuspendBuildTemplate(b.get('name'), False)
            b.is_priority_building = False
# ============================================================
# ============================================================
class StateSurvived(FSMState):
    name = 'survived'

    def __init__(self,item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateSurvived'

    def on_exit(self, next_state):
        self.item.activate()
        self.item.on_survived_activate()
# ============================================================
class StateThrown(FSMState):
    name = 'thrown'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateThrown'

    def on_enter(self, evID):
        b = self.item
        b.show_lock()  # замок, если нет доступных деревьев
        # отправить юнита в главное здание, если это допустимо
        task = b.get_participating_task('call_worker_to_building')
        if task:    # если отменяем апгрейд
            task.cancel()
        b.return_worker_home()
        _fsm_state = b.FSM.GetStateID()
        if _fsm_state != 'init':
            b.PlaySound('SND_BUILDING_ABANDONED')
        b.switch_to_blocked_level()  # здание брошено
# ============================================================
# ============================================================
class StateMapPlace(FSMState):
    name = 'map_place'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateMapPlace'
# ============================================================
# ============================================================
class StatePreremoving(FSMState):
    name = 'preremoving'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StatePreremoving'

    def on_enter(self, evID):
        b = self.item
        b.lost_resource()       # ресурс производства теряется
        if b.has_workers():
            _unit = b.get_worker()
            if _unit:
                _unit.show()
                #_unit.Drawer.StopAnimation('')
                _unit.stop_walk()
                #b.worker_units.remove(_unit)
        b.start_final_countdown()
        b.show_arrow(False)

    def on_exit(self, next_state):
        if next_state != 'removing':
            b = self.item
            b.cancel_countdown()
            if b.has_workers():
                _unit = b.get_worker()
                _unit.hide()
        self.item.StopRoundBar()
# ============================================================
# ============================================================
class StateRemoving(FSMState):
    name = 'removing'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateRemoving'

    def on_enter(self, evID):
        b = self.item
        b.is_deactivated = True # чтобы их не включили нигде
        b.non_selectable = True
        #_show_out_layers = b.shaded_layers[:]
        #_show_out_layers.extend(['bush' + str(i+1) for i in range(0,6)])
        #_show_out_layers.append('icons')
        _show_out_layers = ''
        b.Drawer.ShowImages('boom')
        b.Drawer.StartEffectOnce('boom')
        b.Drawer.ShowOut(_show_out_layers, 1800)    # плавное гашение здания
        b.Drawer.ShowImages(['anim'], False)
        b.Drawer.StopEffect('anim')
        b.Signals.Restart('building_need_afterdeath', 1000)
        b.Signals.Restart('add_afterdeath_item', 200)
        b.PlaySound('SND_BUILDING_DESTROY')
        uid = b.get('uid')
        map_index = b.get('locind')
        TMgr.process_removing_item(uid, map_index)  # всеравно здание уже будет уничтожено

    def on_state_changed(self):
        b = self.item
        b.on_non_functional()

    def on_exit(self, next_state):
        b = self.item
# ============================================================
# ============================================================
class StateRemovingFinal(FSMState):
    name = 'removing_final'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateRemovingFinal'

    def on_enter(self, evID):
        b = self.item
        b.Signals.Restart('building_dead', 1000)

    def on_exit(self, next_state):
        b = self.item
        _uid = b.get('uid')
        if _uid == '4449':
            if LBoard.Core.episode == 1 and LBoard.Core.level == 1:
                _need_help = LBoard.Core.is_help_needed(1)
                if _need_help:
                    #Camera.MoveTo(self)
                    UI.open_help(1)
        _unit = None
        BMgr.RemoveItemFromMap(b)
        b.unreserve_action_cells()
        returning_unit = b.return_worker_home()      # отпускаем работника
        b.drop_cost_items(returning_unit)         # выбрасываем возвратную стоимость на карту
        #BMgr.remove_building(b)     # удаляем здание с карты
        EMgr.send_event('building_removed', None)
# ============================================================
# ============================================================